#include <stdio.h>
#include <string.h>

#include "xtux.h"
#include "server.h"
#include "entity.h"
#include "sv_map.h"
#include "game.h"
#include "clients.h"
#include "sv_net.h"
#include "sv_netmsg_send.h"

extern int class_population[NUM_ENT_CLASSES];

game_t game;
int told;

void game_start(void)
{

    if( game.timelimit ) {
	game.endtime = gettime() + M_SEC * game.timelimit;
	printf("Timelimit = %d seconds\n", game.timelimit);
    } else
	game.endtime = 0;

}



void game_update(void)
{
    msec_t now;

    now = gettime();

    if( game.changelevel || (game.endtime && now > game.endtime) ) {
	if( game.next_map_name[0] == '\0' ) { /* Empty */
	    printf("Restarting current level\n");
	    sv_map_changelevel(game.map_name, game.mode); /* Restart map */
	} else {
	    printf("Changing level to %s\n", game.next_map_name);
	    sv_map_changelevel(game.next_map_name, game.mode);
	}
	game.changelevel = 0;
    }

    if( game.objective_complete == 0 ) {
	if( game.mode == SAVETHEWORLD ) {
	    if( game.objective == GAME_ELIMINATE_CLASS ) {
		if( class_population[ game.class ] == 0 ) {
		    sv_netmsg_send_gamemessage(0, game.success_msg, 1);
		    /* Set level to change in 3 seconds */
		    game.endtime = now + M_SEC * 3;
		    game.objective_complete = 1;
		}
	    }
	} else if( game.mode == BUNNYBASH ) {
	    if( class_population[ NEUTRAL ] == 0 ) {
		sv_netmsg_send_gamemessage(0, "What's up doc?", 1);
		/* Set level to change in 3 seconds */
		game.endtime = now + M_SEC * 3;
		game.objective_complete = 1;
	    }
	}
    }


}


void game_close(void)
{

    memset(game.map_name, 0, NETMSG_STRLEN);
    memset(game.next_map_name, 0, NETMSG_STRLEN);
    strncpy(game.success_msg, "Objective Complete", TEXTMESSAGE_STRLEN);
    game.changelevel = 0;
    game.objective = 0;
    game.objective_complete = 0;

}
